﻿
Imports System.Windows.Forms.VisualStyles.VisualStyleElement.ToolBar

Partial Class Form1
    Inherits System.Windows.Forms.Form

    ' ===================================================================================================
    '  INIT BUTTONS
    ' ===================================================================================================
    ' TODO --- INIT BUTTONS

    Private OldCode As String = ""
    Private Sub InitButtons()
        ' ----------------------------------------------- test if code is changed
        Dim code As String = GetBlocklyCode()
        If code = oldcode Then Return
        oldcode = code
        ' -----------------------------------------------
        SetInitialButtonNamesColorsAndPositions()
        ResetButtonIdentifiersAndSlots()
        ReadFunctionNames(code)
        For i As Int32 = 0 To FunctionNames.Length - 1
            SetButton((i + 1).ToString, FunctionNames(i), 0)
        Next
    End Sub

    Private FunctionNames(-1) As String
    Private Sub ReadFunctionNames(ByVal code As String)
        ReDim FunctionNames(-1)
        Dim i As Int32
        Dim bc() As String = code.Split(CChar(vbLf))
        For n As Int32 = 0 To bc.Length - 1
            If bc(n).StartsWith("function ") Then
                Dim str As String = bc(n).Substring(9).Replace("() {", "")
                If Not str.StartsWith("math") Then
                    ReDim Preserve FunctionNames(FunctionNames.Length)
                    FunctionNames(FunctionNames.Length - 1) = str
                End If
                i += 1
                End If
        Next
    End Sub

    ' TODO -- Button click
    Private Sub Buttons_Click(ByVal sender As Object, ByVal e As System.EventArgs)
        '
        ExecuteScriptFunction("resetInterpreter()")
        ExecuteScriptFunction("initInterpreter()")
        ' -------------------------------------------------------
        Dim txt As String = CType(sender, CheckBox).Text
        ExecuteScriptFunction("appendFuctionBlock('" + txt + "')")
        ' -------------------------------------------------------
        AddTextToOutputBox(vbCrLf + "DEBUG: Starting function " + txt)
        ' -------------------------------------------------------
        Running = True
        UpdateStartStopButtons()
        StartRunningTime()
        ExecuteScript()
    End Sub


    ' ===================================================================================================
    '  BUTTON FUNCTIONS
    ' ===================================================================================================
    Friend Const NBUTTONS As Int32 = 128
    Private Const ButtonsWidth As Int32 = 160
    Private Const ButtonsHeight As Int32 = 46
    Private Const ButtonsLeft As Int32 = 9
    Private Const ButtonsTop As Int32 = 19

    Private ReadOnly Buttons(NBUTTONS - 1) As CheckBox
    Private ReadOnly ButtonEnabled(NBUTTONS - 1) As Boolean
    Private ReadOnly ButtonIdentifiers(NBUTTONS - 1) As String
    Private ReadOnly ButtonDeclarationLines(NBUTTONS - 1) As Int32
    Private ReadOnly ButtonSlots(NBUTTONS - 1) As Int32
    Private ReadOnly ButtonSlotsOldValues(NBUTTONS - 1) As Single
    Private ReadOnly ButtonFlashingFrequency(NBUTTONS - 1) As Single
    Private ReadOnly ButtonBackColor(NBUTTONS - 1) As Color
    Private ReadOnly ButtonForeColor(NBUTTONS - 1) As Color
    Private ReadOnly ButtonFlashingTimer(NBUTTONS - 1) As Single
    Private ReadOnly ButtonFlashingColor1(NBUTTONS - 1) As Color
    Private ReadOnly ButtonFlashingColor2(NBUTTONS - 1) As Color

    Private Sub SetButtonsToFront()
        For i As Int32 = 0 To NBUTTONS - 1
            Buttons(i).BringToFront()
        Next
    End Sub

    Private Sub Buttons_Create()
        For i As Int32 = 0 To NBUTTONS - 1
            Buttons(i) = New CheckBox
            With Buttons(i)
                .Appearance = Appearance.Button
                .FlatStyle = FlatStyle.Flat
                .FlatAppearance.BorderColor = Color.DarkGray
                .FlatAppearance.BorderSize = 2
                .FlatAppearance.CheckedBackColor = Color.OldLace
                .Font = New Font("Tahoma", 8.25)
                .Size = New Size(ButtonsWidth, ButtonsHeight)
                .Name = "Button_" + (i + 1).ToString
                .TextAlign = ContentAlignment.MiddleCenter
                .UseVisualStyleBackColor = False
                .Visible = False
            End With
            AddHandler Buttons(i).Click, AddressOf Buttons_Click
            GroupBox1.Controls.AddRange(Buttons)
        Next
    End Sub

    Friend Sub SetInitialButtonNamesColorsAndPositions()
        OldCode = ""
        ' ------------------------------------------------------------------------ set name and colors
        For i As Int32 = 0 To NBUTTONS - 1
            With Buttons(i)
                .Text = ""
                .BackColor = Color.OldLace
                .ForeColor = Color.Black
                ButtonBackColor(i) = .BackColor
                ButtonForeColor(i) = .ForeColor
                EnableButton(i)
                ButtonFlashingFrequency(i) = 0
                .FlatAppearance.BorderSize = 1
                .FlatAppearance.BorderColor = Color.Gray
            End With
        Next
        ' ------------------------------------------------------------------------ set position
        Dim x As Int32 = ButtonsLeft
        Dim y As Int32 = ButtonsTop
        Dim dw As Int32 = ButtonsWidth
        Dim dh As Int32 = ButtonsHeight
        Dim row As Int32
        Dim col As Int32
        For i As Int32 = 0 To NBUTTONS - 1
            With Buttons(i)
                row = i Mod 16
                col = i \ 16
                .Left = x + dw * col
                .Top = y + dh * row
            End With
        Next
        SetVisibleButtons()
    End Sub

    Private ButtonColumns As Int32
    Private OldButtonColumns As Int32

    Private Sub SetVisibleButtons()
        If Not EventsAreEnabled Then Return
        ' ---------------------------------------------------------------
        Dim b As CheckBox
        Dim ypos As Int32
        Dim column As Int32
        If Running Then
            ypos = Chk_Run.Top - 2
        Else
            ypos = Chk_Undo.Top - 2
        End If
        ButtonColumns = 0
        For i As Int32 = 0 To NBUTTONS - 1
            b = Buttons(i)
            If b.Text <> Nothing And Not b.Text.StartsWith("_") Then
                If i > 15 Then
                    b.Visible = b.Bottom < GroupBox1.ClientSize.Height - 4
                Else
                    b.Visible = b.Bottom < ypos
                End If
                SetButtonFontSize(b)

                column = i \ 16
                If column > ButtonColumns Then
                    ButtonColumns = column
                End If
            Else
                b.Visible = False
            End If
        Next
        If ButtonColumns <> OldButtonColumns Then
            OldButtonColumns = ButtonColumns
            ' ---------------------------------------------------------------
            ResizeControlAndProgramPanels()
            ' ---------------------------------------------------------------
            Me.MinimumSize = New Size(GroupBox1.Left + 16, Buttons(0).Height * 7)
            ' ---------------------------------------------------------------
            ShowHideTextAndTools()
        End If
    End Sub

    Private Sub EnableAllButtons()
        For i As Int32 = 0 To NBUTTONS - 1
            EnableButton(i)
        Next
    End Sub
    Private Sub DisableAllButtons()
        For i As Int32 = 0 To NBUTTONS - 1
            DisableButton(i)
        Next
    End Sub
    Private Sub EnableButton(ByVal n As Int32)
        ButtonEnabled(n) = True
        With Buttons(n)
            .ForeColor = ButtonForeColor(n)
            .BackColor = ButtonBackColor(n)
            .FlatAppearance.MouseOverBackColor = ModifiedColor(.BackColor, 90)
        End With
    End Sub
    Private Sub DisableButton(ByVal n As Int32)
        ButtonEnabled(n) = False
        With Buttons(n)
            .ForeColor = Color.FromArgb(80, 80, 80)
            .BackColor = Color.FromArgb(210, 210, 210)
            .FlatAppearance.MouseOverBackColor = Color.FromArgb(200, 200, 200)
        End With
    End Sub

    Private Sub SetButtonFontSize(ByVal b As CheckBox)
        '
        Dim fontsize As Single = b.Height / 5.0F
        ' --------------------------------------------------------- avoid errors if the form is zero size
        If fontsize = 0 Then fontsize = 9.2
        ' ---------------------------------------------------------
        b.Font = New Font("Tahoma", fontsize * 1.6F)
        Dim pixels As Size = TextRenderer.MeasureText(b.Text, b.Font)
        If b.Text.Contains(vbCrLf) Then
            ' ----------------------------------------------------- font for two lines
            b.Font = New Font("Tahoma", fontsize * 1.1F)
            ' ----------------------------------------------------- try to correct for long names also if containing spaces
            Dim sa() As String = Strings.Split(b.Text, vbCrLf)
            Dim MaxWidth As Int32 = -1
            For i As Int32 = 0 To sa.Length - 1
                pixels = TextRenderer.MeasureText(sa(i), b.Font)
                If pixels.Width > MaxWidth Then
                    MaxWidth = pixels.Width
                End If
            Next
            If MaxWidth >= b.Width - 10 Then
                b.Font = New Font("Tahoma", CSng(fontsize * 1.1F * (b.Width - 10) / MaxWidth))
            End If
        ElseIf pixels.Width >= b.Width - 10 Then
            b.Font = New Font("Tahoma", CSng(fontsize * 1.5F * (b.Width - 10) / pixels.Width))
        End If
    End Sub

    Friend Function ModifiedColor(ByVal c As Color, ByVal delta As Int32) As Color
        Dim r As Int32 = c.R + delta
        Dim g As Int32 = c.G + delta
        Dim b As Int32 = c.B + delta
        If r < 0 Then r = 0
        If g < 0 Then g = 0
        If b < 0 Then b = 0
        If r > 255 Then r = 255
        If g > 255 Then g = 255
        If b > 255 Then b = 255
        Return Color.FromArgb(r, g, b)
    End Function

    Private Sub ResetButtonIdentifiersAndSlots()
        For i As Int32 = 0 To NBUTTONS - 1
            ButtonSlots(i) = -1
            ButtonIdentifiers(i) = ""
        Next
    End Sub

    Private Function GetButtonByIdentifier(ByVal IdString As String) As Int32
        IdString = IdString.ToLower
        For i As Int32 = 0 To NBUTTONS - 1
            If ButtonIdentifiers(i).ToLower = IdString Then
                Return i + 1
            End If
        Next
        Return 0
    End Function

    Private Sub ResizeControlAndProgramPanels()
        GroupBox1.Width = Buttons(ButtonColumns * 16).Right + Buttons(0).Left
        GroupBox_MainArea.Left = GroupBox1.Right + 6
        GroupBox_MainArea.Width = Me.ClientSize.Width - GroupBox_MainArea.Left - 6
    End Sub


    ' =============================================================================================
    '   SET BUTTON
    ' =============================================================================================

    Private Sub SetButton(ByVal BtnID As String, ByVal text As String, ByVal line As Int32)

        ' ------------------------------------------------- test if the ID is number or identifier
        Dim IdentifiedByNumber As Boolean = True
        Dim nbutton As Int32 = CInt(Val(BtnID))
        If nbutton = 0 Then
            nbutton = GetButtonByIdentifier(BtnID)
            IdentifiedByNumber = False
        End If
        If nbutton < 1 Or nbutton > NBUTTONS Then Return
        ' -------------------------------------------------
        Dim b As CheckBox
        b = Buttons(nbutton - 1)
        If b Is Nothing Then Return
        If text = Nothing Then
            b.Text = Nothing
            ButtonIdentifiers(nbutton - 1) = ""
            SetVisibleButtons()
            Return
        End If
        Select Case text.ToLower
            Case "enabled"
                EnableButton(nbutton - 1)
                SetVisibleButtons()
            Case "disabled"
                DisableButton(nbutton - 1)
                SetVisibleButtons()
            Case Else
                text = text.Replace("""", "")
                If text <> b.Text Then
                    b.Text = text
                    If IdentifiedByNumber Then
                        ButtonDeclarationLines(nbutton - 1) = line
                        ButtonIdentifiers(nbutton - 1) = text
                        SetVisibleButtons()
                    End If
                    SetButtonFontSize(b)
                    b.Refresh()
                End If
        End Select
    End Sub

End Class
